#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire2900eight4xi.py">
#<abstract4xi abstract = "fires to direction eight and to distance 2900"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2eight4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
       
# -------------------------------------------------------------------------------------------------
# SHOT2EIGHT - COORDINATE SIGNS OF SHOOT2EIGHT4XI: (X - ,Y - ,Z -)
# -------------------------------------------------------------------------------------------------    
global shot2eight29004xi

#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = True
         
shot2eight29004xi = {
                1:'-1022x-315y-2695z',
                2:'-1047x-2115y-1684z',
                3:'-1048x-1838y-1982z',
                4:'-1048x-836y-2571z',
                5:'-1063x-267y-2684z',
                6:'-1095x-2677y-202z',
                7:'-109x-968y-2837z',
                8:'-1102x-217y-2673z',
                9:'-1112x-795y-2557z',
                10:'-1139x-162y-2661z',
                11:'-114x-500y-2854z',
                12:'-1153x-1797y-1961z',
                13:'-1165x-2072y-1660z',
                14:'-1172x-105y-2650z',
                15:'-1173x-749y-2543z',
                16:'-1233x-699y-2529z',
                17:'-1235x-2618y-173z',
                18:'-1257x-1750y-1939z',
                19:'-1280x-2022y-1637z',
                20:'-1290x-645y-2515z',
                21:'-1345x-587y-2500z',
                22:'-1359x-1697y-1918z',
                23:'-1371x-2551y-144z',
                24:'-1394x-1965y-1613z',
                25:'-1398x-524y-2485z',
                26:'-1447x-458y-2470z',
                27:'-1459x-1638y-1896z',
                28:'-148x-521y-2848z',
                29:'-1493x-388y-2455z',
                30:'-1503x-2477y-115z',
                31:'-1505x-1902y-1588z',
                32:'-1556x-1572y-1874z',
                33:'-158x-956y-2733z',
                34:'-1613x-1832y-1564z',
                35:'-1631x-2395y-86z',
                36:'-1650x-1501y-1852z',
                37:'-1717x-1757y-1540z',
                38:'-1741x-1425y-1829z',
                39:'-1755x-2307y-57z',
                40:'-1818x-1675y-1515z',
                41:'-1827x-1342y-1807z',
                42:'-184x-539y-2843z',
                43:'-1873x-2213y-28z',
                44:'-1910x-1255y-1784z',
                45:'-1915x-1587y-1490z',
                46:'-193x-1941y-2145z',
                47:'-1987x-2112y0z',
                48:'-1989x-1162y-1761z',
                49:'-2007x-1493y-1465z',
                50:'-2062x-1064y-1738z',
                51:'-208x-2227y-1845z',
                52:'-2095x-1394y-1440z',
                53:'-2131x-962y-1715z',
                54:'-213x-2867y-375z',
                55:'-214x-973y-2723z',
                56:'-2177x-1290y-1415z',
                57:'-2194x-855y-1691z',
                58:'-223x-555y-2837z',
                59:'-2252x-744y-1667z',
                60:'-2254x-1181y-1389z',
                61:'-2304x-630y-1644z',
                62:'-2325x-1067y-1364z',
                63:'-2349x-512y-1620z',
                64:'-2389x-391y-1596z',
                65:'-2391x-949y-1338z',
                66:'-2422x-267y-1571z',
                67:'-2449x-826y-1312z',
                68:'-2502x-701y-1287z',
                69:'-2548x-571y-1261z',
                70:'-263x-569y-2831z',
                71:'-272x-987y-2713z',
                72:'-28x-426y-2868z',
                73:'-298x-1949y-2125z',
                74:'-306x-579y-2824z',
                75:'-327x-2231y-1823z',
                76:'-332x-997y-2702z',
                77:'-350x-586y-2818z',
                78:'-363x-2856y-346z',
                79:'-393x-1003y-2692z',
                80:'-396x-591y-2811z',
                81:'-404x-1952y-2106z',
                82:'-443x-591y-2804z',
                83:'-447x-2228y-1800z',
                84:'-456x-1006y-2681z',
                85:'-492x-589y-2796z',
                86:'-511x-1948y-2085z',
                87:'-513x-2836y-317z',
                88:'-521x-1004y-2670z',
                89:'-541x-583y-2788z',
                90:'-54x-453y-2863z',
                91:'-567x-2219y-1777z',
                92:'-586x-998y-2658z',
                93:'-591x-573y-2780z',
                94:'-618x-1939y-2065z',
                95:'-63x-2870y-404z',
                96:'-641x-560y-2772z',
                97:'-652x-989y-2646z',
                98:'-661x-2808y-289z',
                99:'-688x-2203y-1754z',
                100:'-691x-542y-2763z',
                101:'-6x-398y-2872z',
                102:'-719x-974y-2634z',
                103:'-726x-1923y-2045z',
                104:'-741x-521y-2754z',
                105:'-785x-956y-2622z',
                106:'-791x-496y-2745z',
                107:'-808x-2181y-1731z',
                108:'-808x-2772y-260z',
                109:'-834x-1901y-2024z',
                110:'-839x-468y-2735z',
                111:'-83x-477y-2859z',
                112:'-852x-932y-2610z',
                113:'-887x-435y-2726z',
                114:'-90x-1927y-2164z ',
                115:'-90x-2216y-1867z',
                116:'-918x-905y-2597z',
                117:'-928x-2151y-1708z',
                118:'-934x-399y-2716z',
                119:'-941x-1872y-2003z',
                120:'-953x-2729y-231z',
                121:'-979x-359y-2705z',
                122:'-984x-873y-2584z '}
#"
#/>


# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire2900eight4xi" usage = "target function for charge2900eight4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire2900eight4xi(queue2eight, consumer_channel2eight, publisher_channel2eight):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE2900EIGHT4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE2900EIGHT4XI -  QUEUE2EIGHT: ", queue2eight)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE2900EIGHT4XI -  CONSUMER_CHANNEL2EIGHT: ", consumer_channel2eight)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE2900EIGHT4XI -  PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE2900EIGHT4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2eight.put(shot2eight29004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE2900EIGHT4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE2900EIGHT4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE2900EIGHT4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2eight8shot2eight29004xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2eight8shot2eight29004xi</nack2put4xi>" 
            
        publisher_channel2eight.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE2900EIGHT4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE2900EIGHT4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE2900EIGHT4XI - RETURNING QUEUE OBJECT QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi())  
        # 
            
    return queue2eight    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire2900eight4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
                                  